/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Cpu.C
**     Project   : pehod
**     Processor : MC9S08AW16CFG
**     Beantype  : MC9S08AW60_44
**     Version   : Bean 01.147, Driver 01.29, CPU db: 2.87.183
**     Datasheet : MC9S08AW60 Rev.1.0 1/2006
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 27.5.2008, 23:53
**     Abstract  :
**         This bean "MC9S08AW60_44" contains initialization of the
**         CPU and provides basic methods and events for CPU core
**         settings.
**     Settings  :
**
**     Contents  :
**         EnableInt  - void Cpu_EnableInt(void);
**         DisableInt - void Cpu_DisableInt(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE Cpu. */

#pragma MESSAGE DISABLE C4002 /* WARNING C4002: Result not used is ignored */

#include "UART.h"
#include "DisplayTimer.h"
#include "CharDrive.h"
#include "ShDI.h"
#include "ShSCK.h"
#include "ShRCK.h"
#include "LED.h"
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Events.h"
#include "Cpu.h"


/* Global variables */
volatile byte CCR_reg;                 /* Current CCR register */


/*
** ===================================================================
**     Method      :  Cpu_Interrupt (bean MC9S08AW60_44)
**
**     Description :
**         The method services unhandled interrupt vectors.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
ISR(Cpu_Interrupt)
{
}



/*
** ===================================================================
**     Method      :  Cpu_DisableInt (bean MC9S08AW60_44)
**
**     Description :
**         Disables maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_DisableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_EnableInt (bean MC9S08AW60_44)
**
**     Description :
**         Enables maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_EnableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  _EntryPoint (bean MC9S08AW60_44)
**
**     Description :
**         Initializes the whole system like timing and so on. At the end 
**         of this function, the C startup is invoked to initialize stack,
**         memory areas and so on.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
extern void _Startup(void);            /* Forward declaration of external startup function declared in file Start12.c */

#pragma NO_FRAME
#pragma NO_EXIT
void _EntryPoint(void)
{
  /* ### MC9S08AW60_44 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* Common initialization of the write once registers */
  /* SOPT: COPE=0,COPT=1,STOPE=0,??=1,??=0,??=0,??=1,??=1 */
  setReg8(SOPT, 0x53);                  
  /* SPMSC1: LVDF=0,LVDACK=0,LVDIE=0,LVDRE=1,LVDSE=1,LVDE=1,??=0,BGBE=0 */
  setReg8(SPMSC1, 0x1C);                
  /* SPMSC2: LVWF=0,LVWACK=0,LVDV=0,LVWV=0,PPDF=0,PPDACK=0,??=0,PPDC=0 */
  setReg8(SPMSC2, 0x00);                
  /* SMCLK: MPE=0,MCSEL=0 */
  clrReg8Bits(SMCLK, 0x17);             
  /*  System clock initialization */
  /* ICGC1: HGO=0,RANGE=1,REFS=1,CLKS1=1,CLKS0=1,OSCSTEN=1,LOCD=0,??=0 */
  setReg8(ICGC1, 0x7C);                 
  /* ICGC2: LOLRE=1,MFD2=0,MFD1=1,MFD0=1,LOCRE=1,RFD2=0,RFD1=0,RFD0=0 */
  setReg8(ICGC2, 0xB8);                 
  ICGTRM = *(unsigned char*)0xFFBE;    /* Initialize ICGTRM register from a non volatile memory */
  while(!ICGS1_LOCK) {                 /* Wait */
  }
  /*** End of PE initialization code after reset ***/

  __asm   jmp _Startup ;               /* Jump to C startup code */

}

/*
** ===================================================================
**     Method      :  PE_low_level_init (bean MC9S08AW60_44)
**
**     Description :
**         Initializes beans and provides common register initialization. 
**         The method is called automatically as a part of the 
**         application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_low_level_init(void)
{
  /* Common initialization of the CPU registers */
  /* PTCD: PTCD3=1 */
  setReg8Bits(PTCD, 0x08);              
  /* PTCDD: PTCDD5=0,PTCDD3=1 */
  clrSetReg8Bits(PTCDD, 0x20, 0x08);    
  /* PTED: PTED7=0,PTED6=0,PTED5=0,PTED4=0,PTED3=0,PTED2=0,PTED1=0,PTED0=0 */
  setReg8(PTED, 0x00);                  
  /* PTEPE: PTEPE7=0,PTEPE6=0,PTEPE5=0,PTEPE4=0,PTEPE3=0,PTEPE2=0,PTEPE1=0,PTEPE0=0 */
  setReg8(PTEPE, 0x00);                 
  /* PTEDD: PTEDD7=1,PTEDD6=1,PTEDD5=1,PTEDD4=1,PTEDD3=1,PTEDD2=1,PTEDD1=1,PTEDD0=1 */
  setReg8(PTEDD, 0xFF);                 
  /* PTFD: PTFD5=0,PTFD4=0,PTFD1=0,PTFD0=0 */
  clrReg8Bits(PTFD, 0x33);              
  /* PTFPE: PTFPE5=0,PTFPE4=0,PTFPE1=0,PTFPE0=0 */
  clrReg8Bits(PTFPE, 0x33);             
  /* PTFDD: PTFDD5=1,PTFDD4=1,PTFDD1=1,PTFDD0=1 */
  setReg8Bits(PTFDD, 0x33);             
  /* PTASE: PTASE1=0,PTASE0=0 */
  clrReg8Bits(PTASE, 0x03);             
  /* PTBSE: PTBSE3=0,PTBSE2=0,PTBSE1=0,PTBSE0=0 */
  clrReg8Bits(PTBSE, 0x0F);             
  /* PTCSE: PTCSE5=0,PTCSE4=0,PTCSE3=0,PTCSE2=0,PTCSE1=0,PTCSE0=0 */
  clrReg8Bits(PTCSE, 0x3F);             
  /* PTDSE: PTDSE3=0,PTDSE2=0,PTDSE1=0,PTDSE0=0 */
  clrReg8Bits(PTDSE, 0x0F);             
  /* PTESE: PTESE7=0,PTESE6=0,PTESE5=0,PTESE4=0,PTESE3=0,PTESE2=0,PTESE1=0,PTESE0=0 */
  setReg8(PTESE, 0x00);                 
  /* PTFSE: PTFSE5=0,PTFSE4=0,PTFSE1=0,PTFSE0=0 */
  clrReg8Bits(PTFSE, 0x33);             
  /* PTGSE: PTGSE6=0,PTGSE5=0,PTGSE3=0,PTGSE2=0,PTGSE1=0,PTGSE0=0 */
  clrReg8Bits(PTGSE, 0x6F);             
  /* PTADS: PTADS7=0,PTADS6=0,PTADS5=0,PTADS4=0,PTADS3=0,PTADS2=0,PTADS1=1,PTADS0=1 */
  setReg8(PTADS, 0x03);                 
  /* PTBDS: PTBDS7=0,PTBDS6=0,PTBDS5=0,PTBDS4=0,PTBDS3=1,PTBDS2=1,PTBDS1=1,PTBDS0=1 */
  setReg8(PTBDS, 0x0F);                 
  /* PTCDS: ??=0,PTCDS6=0,PTCDS5=1,PTCDS4=1,PTCDS3=1,PTCDS2=1,PTCDS1=1,PTCDS0=1 */
  setReg8(PTCDS, 0x3F);                 
  /* PTDDS: PTDDS7=0,PTDDS6=0,PTDDS5=0,PTDDS4=0,PTDDS3=1,PTDDS2=1,PTDDS1=1,PTDDS0=1 */
  setReg8(PTDDS, 0x0F);                 
  /* PTEDS: PTEDS7=1,PTEDS6=1,PTEDS5=1,PTEDS4=1,PTEDS3=1,PTEDS2=1,PTEDS1=1,PTEDS0=1 */
  setReg8(PTEDS, 0xFF);                 
  /* PTFDS: PTFDS7=0,PTFDS6=0,PTFDS5=1,PTFDS4=1,PTFDS3=0,PTFDS2=0,PTFDS1=1,PTFDS0=1 */
  setReg8(PTFDS, 0x33);                 
  /* PTGDS: ??=0,PTGDS6=1,PTGDS5=1,PTGDS4=0,PTGDS3=1,PTGDS2=1,PTGDS1=1,PTGDS0=1 */
  setReg8(PTGDS, 0x6F);                 
  /* ### Shared modules init code ... */
  /* ### Asynchro serial "UART" init code ... */
  UART_Init();
  /* ### TimerInt "DisplayTimer" init code ... */
  DisplayTimer_Init();
  /* ### ByteIO "CharDrive" init code ... */
  /* ### BitIO "ShDI" init code ... */
  /* ### BitIO "ShSCK" init code ... */
  /* ### BitIO "ShRCK" init code ... */
  /* ### BitIO "LED" init code ... */
  __EI();                              /* Enable interrupts */
}

/* Initialization of the CPU registers in FLASH */

/* NVPROT: FPS7=1,FPS6=1,FPS5=1,FPS4=1,FPS3=1,FPS2=1,FPS1=1,FPDIS=1 */
const unsigned char NVPROT_INIT @0x0000FFBD = 0xFF;

/* NVOPT: KEYEN=0,FNORED=1,??=1,??=1,??=1,??=1,SEC01=1,SEC00=0 */
const unsigned char NVOPT_INIT @0x0000FFBF = 0x7E;

/* END Cpu. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 3.01 [03.92]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
