/** ###################################################################
**     Filename  : GPS.C
**     Project   : pehod
**     Processor : MC9S08AW16CFG
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 26.5.2008, 22:56
**     Contents  :
**         User source code
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE GPS */

/*************************************************************************
 *
 * Projekt:     GPS hodiny
 * Autor:       Ales Povalac, <alpov@alpov.net>
 *
 *************************************************************************/         

#include <string.h>
#include "UART.h"
#include "LED.h"
#include "GPS.h"
#include "Display.h"


volatile static unsigned char enable_rcvd = 0;


void delay1(void)
{
  unsigned long d;
  
  for (d = 0; d < 200000; d++) {
    /* wait */
  }
}

                   
void delay2(void)
{
  unsigned long d;
  
  for (d = 0; d < 80000; d++) {
    /* wait */
  }
}

                   
void send_str(char *s)
{
  unsigned int len;
  
  UART_SendBlock(s, strlen(s), &len);
  while (UART_GetCharsInTxBuf() > 0);  
  UART_ClearTxBuf();
  delay2();
}


void init_gps(void)
{
	delay1();
//  send_str("$LTC,1000,0*6A\r\n");              // GPS Interrupt
//	send_str("$PSRF100,1,4800,8,1,0*0E\r\n");    // SetSerialPort, 4800Bd, 8N1
//	delay1();
  send_str("$LTC,1000,0*6A\r\n");              // GPS Interrupt
	send_str("$PSRF103,00,00,00,01*24\r\n");     // GGA disable
	send_str("$PSRF103,01,00,00,01*25\r\n");     // GLL disable
  send_str("$PSRF103,02,00,00,01*26\r\n");     // GSA disable
	send_str("$PSRF103,03,00,00,01*27\r\n");     // GSV disable
	send_str("$PSRF103,04,00,01,01*21\r\n");     // RMC enable; rate 1 sec
	send_str("$PSRF103,05,00,00,01*21\r\n");     // VTG disable

  enable_rcvd = 1;
}


void gps_datarcvd(void)
{
  static char s[128];
  static unsigned char pos = 0;
  char ch;
  char *q;
  unsigned char hour, min, sec, month, day;
  
  
  if (UART_RecvChar(&ch) == ERR_OK) {

    if (!enable_rcvd)
      return;

    if (ch == '$')
      pos = 0;
    
    if (pos >= 127) pos = 127;
    s[pos++] = ch;
    
    if (ch == '*') {
      /* rozparsovat a poslat na displej */
   
      if (s[1] != 'G' || s[2] != 'P' || s[3] != 'R' || s[4] != 'M' || s[5] != 'C')
        return;
      
      LED_NegVal();
      q = s;
      
      // $GPRMC,162127.847,V,0000.0000,N,00000.0000,E,0.00,0.00,270508,,*16   
      while (*q != ',') q++;
      q++;
      
      // 162127.847,V,0000.0000,N,00000.0000,E,0.00,0.00,270508,,*16   
      hour = (*q++ - '0') * 10 + (*q++ - '0');
      min = (*q++ - '0') * 10 + (*q++ - '0');
      sec = (*q++ - '0') * 10 + (*q++ - '0');
      
      // .847,V,0000.0000,N,00000.0000,E,0.00,0.00,270508,,*16   
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      while (*q != ',') q++;
      q++;
      
      // 270508,,*16   
      day = (*q++ - '0') * 10 + (*q++ - '0');
      month = (*q++ - '0') * 10 + (*q++ - '0');
   
      /* konec parsovani */
      
      show_time(hour, min, sec);
      show_date(day, month);      
    }
  }
}


/* END GPS */
