/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : LED.C
**     Project   : pehod
**     Processor : MC9S08AW16CFG
**     Beantype  : BitIO
**     Version   : Bean 02.068, Driver 03.14, CPU db: 2.87.183
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 27.5.2008, 15:19
**     Abstract  :
**         This bean "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Note: This bean is set to work in Output direction only.
**         Methods of this bean are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings  :
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       7             |  PTF5_TPM2CH1
**             ----------------------------------------------------
**
**         Port name                   : PTF
**
**         Bit number (in port)        : 5
**         Bit mask of the port        : $0020
**
**         Initial direction           : Output (direction cannot be changed)
**         Initial output value        : 0
**         Initial pull option         : off
**
**         Port data register          : PTFD      [$000A]
**         Port control register       : PTFDD     [$000B]
**
**         Optimization for            : speed
**     Contents  :
**         GetVal - bool LED_GetVal(void);
**         PutVal - void LED_PutVal(bool Val);
**         ClrVal - void LED_ClrVal(void);
**         SetVal - void LED_SetVal(void);
**         NegVal - void LED_NegVal(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE LED. */

#include "LED.h"
  /* Including shared modules, which are used in the whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Cpu.h"


/*
** ===================================================================
**     Method      :  LED_GetVal (bean BitIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**         Note: This bean is set to work in Output direction only.
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
/*
bool LED_GetVal(void)

**  This method is implemented as a macro. See LED.h file.  **
*/

/*
** ===================================================================
**     Method      :  LED_PutVal (bean BitIO)
**
**     Description :
**         This method writes the new output value.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
void LED_PutVal(bool Val)
{
  if (Val) {
    setReg8Bits(PTFD, 0x20);           /* PTFD5=0x01 */
  } else { /* !Val */
    clrReg8Bits(PTFD, 0x20);           /* PTFD5=0x00 */
  } /* !Val */
}

/*
** ===================================================================
**     Method      :  LED_ClrVal (bean BitIO)
**
**     Description :
**         This method clears (sets to zero) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void LED_ClrVal(void)

**  This method is implemented as a macro. See LED.h file.  **
*/

/*
** ===================================================================
**     Method      :  LED_SetVal (bean BitIO)
**
**     Description :
**         This method sets (sets to one) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void LED_SetVal(void)

**  This method is implemented as a macro. See LED.h file.  **
*/

/*
** ===================================================================
**     Method      :  LED_NegVal (bean BitIO)
**
**     Description :
**         This method negates (inverts) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void LED_NegVal(void)

**  This method is implemented as a macro. See LED.h file.  **
*/


/* END LED. */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 3.01 [03.92]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
